<?php
	/*
		Plugin Name: Shane Web Guy Portfolio
		Plugin URI: http://shanewebguy.com
		Description: Customized Portfolio  Created with custom posts with quicksand integration and custom javascript. category thumbnails are 150x180, post featured images are set to 150x180px ratio or 1000x1213px. Use this ratio to preserve image aspect. 
		Version: 1.0
		Author: Shane Clark
		Author URI: http://shanewebguy.com
 License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html


		* NOTE: this is set to a page with 970px width, refer to css for changes.
		* uses quicksand, easing, 
		* todo: pagination, problem is with logical and animation bugs with quicksand
		* quicksand was not intended for pagination as its loses it logic purpose to filter
	*/
	
	add_action('init', 'create_shanewebportfolio_cpt');
	
	function bkswgactivate(){
		create_shanewebportfolio_cpt();
		global $wp_rewrite;
		$wp_rewrite->flush_rules();
	}
	
	register_activation_hook( __FILE__, 'bkswgactivate' );
	
	
	function bkswgdeactivate(){
		global $wp_rewrite;
		$wp_rewrite->flush_rules();
	}
	
	register_deactivation_hook( __FILE__, 'bkswgdeactivate' );
	
	function create_shanewebportfolio_cpt() 
	{
		$labels = array(
		'name' => _x('SWG Portfolio', 'swgportfolio'),
		'singular_name' => _x('Portfolio', 'shaneportfolio'),
		'add_new' => _x('Add New', 'newswbportfolio'),
		'add_new_item' => __('Add New Portfolio'),
		'edit_item' => __('Edit Item'),
		'new_item' => __('New Item'),
		'view_item' => __('View Item'),
		'search_items' => __('Search Items'),
		'not_found' =>  __('No items found'),
		'not_found_in_trash' => __('No items found in Trash'), 
		'parent_item_colon' => '|',
		);
		$args = array(
		'labels' => $labels,
		'public' => true,
		'show_ui' => true, 
		'query_var' => true,
		'rewrite' => array('slug' => 'swg-portfolio-page'), 
		'capability_type' => 'page',
		'hierarchical' => true,
		'menu_position' => 20,
		'has_archive' => true,
		'taxonomies' => array('swg_cats'),
		'supports' => array('title','editor','thumbnail','excerpt', 'comments')
		); 
		register_post_type('swgportfolio',$args);
		
		register_taxonomy(
		'swg_cats',
		'swgportfolio',
		array(
		'label' => __( 'SWGP Categories' ),
		'rewrite' => true,
		'show_ui' => true,
		'query_var' => true,
		'hierarchical' => true,
		)
		);
		
		add_image_size( 'swg_thumb', 150, 180, true );
		add_image_size( 'swg_med', 250, 303, true );
		/*
			if(function_exists()){
			add_meta_box('aiosp',__('All in One SEO Pack', 'all_in_one_seo_pack'),'aiosp_meta','page');
			}
		*/
		
		if (function_exists('aioseop_activate')) {
			
			
			add_action( 'manage_swgportfolio_posts_custom_column' , 'swgportfolio_column', 10, 2 );
			
			
		}
		
	}
	
	
	
	function swgportfolio_column( $column, $post_id ) {
		switch ( $column ) {
			case 'seotitle':
			echo htmlspecialchars(stripcslashes(get_post_meta($post_id,'_aioseop_title',TRUE)));
			break;
			case 'seokeywords':
			echo htmlspecialchars(stripcslashes(get_post_meta($post_id,'_aioseop_keywords',TRUE)));
			break;
			case 'seodesc':
			echo htmlspecialchars(stripcslashes(get_post_meta($post_id,'_aioseop_description',TRUE)));
			break;
			
			
		}
	}	
	
	function add_script_swg_lib(){
		if(!is_admin()){
			//	if(is_page_template('shane-ptfolio.php')){
			
			wp_register_script('quicksand','/wp-content/plugins/shane-web-guy-portfolio/js/quicksand.js',array('jquery')  );
			wp_register_script('bkscript','/wp-content/plugins/shane-web-guy-portfolio/js/bkscript.js',array('jquery')  );
			
			wp_enqueue_script('quicksand');
			wp_enqueue_script('bkscript');
			
			
			// }
		}
	}
	
	function add_style_swg_lib(){
		if(!is_admin()){
			wp_register_style('quicksandstyle','/wp-content/plugins/shane-web-guy-portfolio/css/quicksandstyle.css');
			wp_register_style('bkjcarousel','/wp-content/plugins/shane-web-guy-portfolio/css/tango/skin.css');
			wp_register_style('swgp-css','/wp-content/plugins/shane-web-guy-portfolio/css/swgp.css');
			wp_enqueue_style('swgp-css');
			wp_enqueue_style('bkjcarousel');
			wp_enqueue_style('quicksandstyle');
		}
	}
	
	add_action( 'wp_footer', 'add_script_swg_lib' );
	
	add_action( 'wp_head', 'add_style_swg_lib' );
	
	add_action('show_portfolio','show_swgportfolio');
	
	function formatDateTime($time){
		$dt= date_create($time);
		return $dt->format('mdy');
	}
	
	function bk_check_excerpt($str){
		if($str == ''){
			return 'Information Coming Soon';
			}else{
			return substr($str,0,150);
		}
	}
	
	function wp_get_attachment_medium_url( $id )
	{
		$medium_array = image_downsize( $id, 'medium' );
		$medium_path = $medium_array[0];
		
		return $medium_path;
	}
	
	
	
	function show_swgportfolio( $shortcode_render = false ){ 
		$plugin_dir_path = plugin_dir_url(__FILE__);
		$swgcustomcats = get_terms('swg_cats');
		$options = swgp_get_swgp_options();
		$_render = '';
		
		
		$strcat ='<div class="swgp-wrapper" id="once-'.wp_create_nonce(rand(1,1000)).'"><div id="bkslides">
		<p id="pbkshowall"><a href="#" id="bknavshowallitems" rel="bkshowallitems">Show All</a></p>
		<ul class="qksplitter jcarousel-skin-tango" id="bkslideshow">';
		$i = 0;
		
		/* loop through terms(category). shows terms with posts only (wordpress default)*/
		foreach ($swgcustomcats as $swgcat){
			$i++;
			
			$strcat .= '<li class="segment-' . $i . '">
			<a href="#" data-value="qk' . $swgcat->taxonomy . $swgcat->term_taxonomy_id . '" title="'.$swgcat->name.'">
			<img src="' . $options['swgp_o2'][$swgcat->term_id]  . '" height="60" width="60" title="'.$swgcat->name.'"/>
			<span>'.$swgcat->name.'</span></a></li>';	
		}
		
		$strcat .='</ul></div> <div class="clear" style="clear:both"></div>';
		
		
		if($shortcode_render)
		$_render .=  $strcat;
		else		
		echo $strcat;
		
		/* Code for preview panel, do not edit, these are hooked to custom javascript functions*/
		$strtpl = '<div id="bkpage_container">';
		
		if($shortcode_render)
		$_render .=  $strtpl;
		else		
		echo $strtpl;
		
		$ob_get = '';
		ob_start();
		
		
		$r = new WP_Query(   array( 'posts_per_page' => -1, 'no_found_rows' => true, 'post_status' => 'publish', 'post_type' => 'swgportfolio' ) );
		$term_args = array('orderby' => 'name', 'order' => 'ASC', 'fields' => 'all');
		if ($r->have_posts()) :
		
		$_render .= '<div id="bkqkcontentpanel">';
		$_render .= '<ul class="qkimage-grid" id="bkquicksand">';
		
		while ($r->have_posts()) : $r->the_post(); 
		
		$i++;
		$strtemp = wp_get_object_terms( $r->post->ID, 'swg_cats',$term_args);		
		
		$taxterms ='';
		$taxtermsclass ='';
		$j = 0;
		/* code for rendering each taxonomy for posts that have multiple terms*/
		foreach($strtemp as $pterm){
			if($j > 0){
				$tdivider = '/';
				$ctdiv = ' ';
				}else{
				$tdivider = '';
				$ctdiv ='';
			}
			$taxterms .= $tdivider . $pterm->name ;
			$taxtermsclass .= $ctdiv . 'qk'. $pterm->taxonomy . $pterm->term_taxonomy_id;
			$j++;	
		}
		
		if(!empty($strtemp)){
			
			$orig_image = wp_get_attachment_url( get_post_thumbnail_id($r->post->ID)); 
			$med_image = wp_get_attachment_medium_url( get_post_thumbnail_id($r->post->ID)); 
			$thumb_image = wp_get_attachment_thumb_url(get_post_thumbnail_id($r->post->ID));
			
			
			if($orig_image != ''){
				$feat_image = get_the_post_thumbnail( $r->post->ID, 'swg_thumb' );
				$med_image = get_the_post_thumbnail( $r->post->ID, 'swg_med' );
				
				
				}else{
				$orig_image = 'http://placehold.it/250x303&text='.$r->post->post_title;
				$med_image = $orig_image;
				$feat_image = '<img src="http://placehold.it/150x180&text='.$r->post->post_title.'" width="150" height="180" title="website coming soon."/>';
				
			}
			
			$_render .= '<li data-id="id-'. $i .'" class="'. $taxtermsclass .' bkcptitem">
			<a href="#" alt="'.get_permalink($r->post->ID).'" class="bkcptlink" rel="'. $taxterms .'">'.$feat_image.'</a>
			<span class="bkprevtitle">'.$r->post->post_title.'</span>
			<strong style="display:none;">'. $i . '</strong>
			<p style="display:none;" class="bkprevmedimg">'.$med_image.'</p>
			<p style="display:none;" class="bkprevpost">'.bk_check_excerpt(get_post_meta( $r->post->ID,'pDescription',true) ).'... <a href="'.  get_permalink($r->post->ID) .'" class="bkcptreadmore">read more</a></p></li>';
		}			
		
		endwhile;
		$_render .= '</ul><div class="clear" style="clear:both"></div></div>';
		wp_reset_postdata();
		
		endif;
		
		$ob_get = ob_get_flush();
		$_render .= '<div id="bkpreview">
		<h3 id="bkpreviewtitle">Project Name: <span></span></h3>
		<h4 id="bkpreviewtype">Project Type: <span></span></h4>
		<a id="bkpreviewpiclink"><img  src="'. $options['swgp_o1']. '" alt="preview site" height="303" width="250"/></a>
		<h5 id="bkprevdesc">Project Description</h5>
		<p id="bkpreviewcont"></p></div>';
		
		
		$_render .= '
		<a href="#content" id="bklinktop">Back to top </a>
		<div class="clear" style="clear:both"></div>';
		$_render .= '</div>';
		
		if($shortcode_render)
		return $_render;
		
		
	}
	
	
	$prefix = '';
	
	$abeta_crm_meta_box = array(
	'id' => 'swgp-meta-box',
	'title' => 'Details',
	'page' => 'swgportfolio',
	'context' => 'normal',
	'priority' => 'high',
	'fields' => array(
	
	array(
	'name' => 'Project Description',
	'desc' => '',
	'id' => $prefix . 'pDescription',
	'type' => 'text',
	'std' => '',
	
	),
	
	array(
	'name' => 'Project URL',
	'desc' => '',
	'id' => $prefix . 'pURL',
	'type' => 'text',
	'std' => '',
	
	),
	
	array(
	'name' => 'Technology Keywords',
	'desc' => '',
	'id' => $prefix . 'tKeywords',
	'type' => 'text',
	'std' => '',
	
	),
	
	)
	);
	
	add_action('admin_menu', 'abeta_add_box');
	
	// Add meta box
	function abeta_add_box() {
		global $abeta_crm_meta_box;
		
		add_meta_box($abeta_crm_meta_box['id'], $abeta_crm_meta_box['title'], 'abeta_show_box', $abeta_crm_meta_box['page'], $abeta_crm_meta_box['context'], $abeta_crm_meta_box['priority']);
	}
	
	function abeta_show_box() {
		global $abeta_crm_meta_box, $post;
		
		// Use nonce for verification
		echo '<input type="hidden" name="abeta_crm_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
		
		echo htmlspecialchars(stripcslashes(get_post_meta($post->ID,'_aioseop_title',TRUE)));
		
		echo '<table class="form-table">';
		
		$output = '';
		
		
		foreach ($abeta_crm_meta_box['fields'] as $field ) {
			$metafieldvalue = get_post_meta($post->ID,$field['id'],true);
			
			$output .= "\t".'<tr>';
			
			$output .= "\t\t".'<th scope="row"><label for="'.esc_attr( $field['id'] ).'">'.$field['name'].'</label></th>'."\n";
			
			$output .= "\t\t".'<td><textarea rows="2" cols="90" name="'.$field['id'].'" id="'.esc_attr( $field['id'] ).'">'.esc_attr( $metafieldvalue ).'</textarea>';
			
			$output .= '<span class="">'.$field['desc'] .'</span></td>'."\n";
			
			$output .= "\t".'</tr>'."\n";
			
			
		}
		
		echo   $output . '</table>';
		
		
	}
	
	add_action('save_post', 'abeta_save_data');
	
	// Save data from meta box
	function abeta_save_data($post_id) {
		global $abeta_crm_meta_box;
		
		// verify nonce
		if (!wp_verify_nonce($_POST['abeta_crm_meta_box_nonce'], basename(__FILE__))) {
			return $post_id;
		}
		
		// check autosave
		if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
			return $post_id;
		}
		
		// check permissions
		if ('page' == $_POST['post_type']) {
			if (!current_user_can('edit_page', $post_id)) {
				return $post_id;
			}
			} elseif (!current_user_can('edit_post', $post_id)) {
			return $post_id;
		}
		
		foreach ($abeta_crm_meta_box['fields'] as $field ) {
			
			$old = get_post_meta($post_id, $field['id'], true);
			$new = $_POST[$field['id']];
			
			if ($new && $new != $old) {
				update_post_meta($post_id, $field['n'], $new);
				} elseif ('' == $new && $old) {
				delete_post_meta($post_id, $field['id'], $old);
				
			}
			
		}
		
		
	}				
	
	
	function render_portfolio_shortcode( $atts, $content = null ) {
		
		extract(shortcode_atts(array(
		
		'name'		=> 'render',
		
		), $atts));
		
		$out = show_swgportfolio( $shortcode_render = true );
		
		return $out;
		
	}
	add_shortcode('swg_portfolio', 'render_portfolio_shortcode');
	
	/* ================================================= */
 	function swgp_option_init() {
		
		$tpl_uri = get_template_directory_uri();
		
		if ( false === swgp_get_swgp_options() )
		
		add_option( 'swgp_option', swgp_get_default_swgp_options() );
		
		
		
		register_setting(
		
		'swgp_option_settings',       // Options group, see settings_fields() call in swgp_option_render_page()
		
		'swgp_option', // Database option, see swgp_get_swgp_options()
		
		'swgp_option_settings_validate' // The sanitization callback, see swgp_option_settings_validate()
		
		);
		
		
		
		// Register our settings field group
		
		add_settings_section(
		
		'general', // Unique identifier for the settings section
		
		'', // Section title (we don't want one)
		
		'__return_false', // Section callback (we don't want anything)
		
		'swgp_options' // Menu slug, used to uniquely identify the page; see swgp_option_add_page()
		
		);
		
		
		
		// Register our individual settings fields
		
		add_settings_field( 'swgp_o1', __( 'Display Place Holder', 'swgp' ), 'swgp_settings_field_swgp_o1', 'swgp_options', 'general' ); 
		add_settings_field( 'swgp_o2', __( 'Category ICONS', 'swgp' ), 'swgp_settings_field_swgp_o2', 'swgp_options', 'general' ); 
		
	}
	
	add_action( 'admin_init', 'swgp_option_init' );
	
	
	
	function swgp_option_page_capability( $capability ) {
		
		return 'edit_theme_options';
		
	}
	
	add_filter( 'option_page_capability_swgp_option_settings', 'swgp_option_page_capability' );
	
	
	
	function swgp_option_add_page() {
		
		$_page =
		add_submenu_page( 'edit.php?post_type=swgportfolio', 'SWGP options', 'SWGP options', 'edit_theme_options', 'swgp_options', 'swgp_option_render_page' );
		
		
		
		
		if ( ! $_page )
		
		return;		
		
	}
	
	
	
	add_action( 'admin_menu', 'swgp_option_add_page' );
	
	
	
	
	
	function swgp_get_default_swgp_options() {
		
		$default_swgp_options = array(
		
		'swgp_o1' => 'http://placehold.it/250x303' ,
		
		'swgp_o2' => '' ,
		
		);
		
		
		
		
		
		return apply_filters( 'swgp_default_swgp_options', $default_swgp_options );
		
	}
	
	
	
	
	
	function swgp_get_swgp_options() {
		
		return get_option( 'swgp_option', swgp_get_default_swgp_options() );
		
	}
	
	
	
	function swgp_settings_field_swgp_o1() {
		
		$options = swgp_get_swgp_options();
		
		
	?>
	
	<input type="text" class="regular-text" name="swgp_option[swgp_o1]" id="swgp_o1_i" value="<?php echo esc_url(  $options['swgp_o1'] ); ?>" /> 
	
	<input id="upload_swgp_o1_button" type="button" class="ubutton button" value="<?php _e( 'Upload', 'abeta' ); ?>" />
	<?php
		
	}
	function swgp_settings_field_swgp_o2() {
		
		$options = swgp_get_swgp_options();
		
		
	?>
	
	<table class="form-table">
		<tbody>
			<tr valign="top">
				<th>Categories</th>
				<th>Icon URL</th>
				<th>&nbsp;</th>
			</tr>	
			<?
				$swgcustomcats = get_terms('swg_cats');
				//	print_r($swgcustomcats);
				
				
				foreach( $swgcustomcats as $_cats){
					printf(
					'<tr valign="top">
					<!--<th align="center" valign="middle"><input type="checkbox" /></th>-->
					<td><label for="%4$s">%3$s</label></td>
					<td><input type="text" class="regular-text" name="swgp_option[swgp_o2][%2$s]" id="%4$s" value="%1$s" /><input id="upload_swgp_o2_button_%2$s" type="button" class="button ubutton swgp_o2_u" value="Upload" /></td>
					<td>&nbsp;</td>
					</tr>'
					, esc_url( $options['swgp_o2'][$_cats->term_id] )
					,$_cats->term_id
					,$_cats->name
					,'term-'.$_cats->term_id
					);
					
					
				}		
				
			?>
			
			
		</tbody>
	</table>
	<?php
		
	}
	
	function swgp_options_enqueue_scripts() {
		wp_register_script( 'swgp-upload', plugins_url( 'js/upload.js', __FILE__ ) , array('jquery','media-upload','thickbox') );
		if ( 'swgportfolio_page_swgp_options' == get_current_screen() -> id ) {
			wp_enqueue_script('jquery');
			wp_enqueue_script('thickbox');
			wp_enqueue_style('thickbox');
			wp_enqueue_script('media-upload');
			wp_enqueue_script('swgp-upload');
		}
	}
	add_action('admin_enqueue_scripts', 'swgp_options_enqueue_scripts');
	
	add_filter( 'gettext', 'replace_thickbox_text' , 1, 2 );
	
	function replace_thickbox_text($translated_text, $text ) {	
		if ( 'Insert into Post' == $text ) {
			$referer = strpos( wp_get_referer(), 'swgp-osettings' );
			if ( $referer != '' ) {
				return __('Insert this...!', 'abeta' );
			}
		}
		
		return $translated_text;
	}
	
	
	function swgp_option_render_page() {
		
	?>
	
	<div class="wrap">
		
		<?php screen_icon(); ?>
		
		<h2><?php printf( __( '%s Options', 'swgp' ), 'SWGP' ); ?></h2>
		
		<?php settings_errors(); ?>
		
		
		<form method="post" action="options.php">
			
			<?php
				
				settings_fields( 'swgp_option_settings' );
				
				do_settings_sections( 'swgp_options' );
				
				submit_button();
				
				
			?>
			
		</form>
		
	</div>
	
	<?php
		
	}
	
	
	
	
	
	function swgp_option_settings_validate( $input ) {
		
		$output = $defaults = swgp_get_default_swgp_options();
		
		
		$output['swgp_o1'] =  $input['swgp_o1'] ;
		
		
		$output['swgp_o2'] =  $input['swgp_o2'] ;
		
		
		return apply_filters( 'swgp_option_settings_validate', $output, $input, $defaults );
		
	}
	
	
